%{!?make_install: %global make_install make install DESTDIR=%{buildroot}}

# $Id: duma.spec 5823 2007-09-05 07:19:16Z dries $
# Authority: dries
# Upstream:  Hayati Ayguen <h_ayguen$web,de>

%define real_version %(echo %{version} | sed 's|\\.|_|g')
# it's a hindrance for debugging with duma to strip the library
%define __strip :

Summary: Detect Unintended Memory Access
Name: duma
Version: 2.5.15
Release: 0.4%{?dist}.4sunshine
License: GPLv2 and LGPLv2
Group: Development/Tools
URL: http://duma.sourceforge.net/
Source: http://downloads.sourceforge.net/%{name}/%{name}_%{real_version}.tar.gz
Patch0: duma-2.5.15-open.patch
Patch1: duma-2.5.15-doc.patch
Patch2: duma-2.5.15-script.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
DUMA (Detect Unintended Memory Access) stops your program on the exact
instruction that overruns (or underruns) a malloc() memory buffer. GDB
will then display the source-code line that causes the bug. It works by
using the virtual-memory hardware to create a red-zone at the border of
each buffer: touch that, and your program stops. It can catch formerly
impossible-to-catch overrun bugs. DUMA is a fork of Bruce Perens'
Electric Fence library.

%package devel
Summary: Header files, libraries and development documentation for %{name}.
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}

%description devel
This package contains the header files, static libraries and development
documentation for %{name}. If you like to develop programs using %{name},
you will need to install %{name}-devel.

%prep
%setup -q -n duma_%{real_version}
%patch0 -p1 -b .open
%patch1 -p1 -b .doc
%patch2 -p1 -b .script
# this part can't be patched:
sed -i 's|\./libduma|%{_libdir}/libduma|' duma.sh

%build
# duma doesn't build with _smp_mflags, duma_config.h and createconf.o are
# missing or truncated, even if specified by make rule first
make CFLAGS="%{optflags}" CPPFLAGS="%{optflags}"

%install
rm -rf %{buildroot}
%{__install} -d -m0755 %{buildroot}%{_bindir}
%{__install} -d -m0755 %{buildroot}%{_mandir}/man3/
%{__install} -d -m0755 %{buildroot}%{_libdir}
%make_install INSTALL="install -p" \
    MAN_INSTALL_DIR="%{buildroot}%{_mandir}/man3/" \
    prefix=%{buildroot}%{_prefix} \
    bindir=%{buildroot}%{_bindir} \
    includedir=%{buildroot}%{_includedir} \
    libdir=%{buildroot}%{_libdir}

%post -p /sbin/ldconfig
%postun -p /sbin/ldconfig

%clean
rm -rf %{buildroot}

%files
%defattr(-, root, root, 0755)
%doc INSTALL README.txt TODO 
%doc COPYING-GPL COPYING-LGPL
%doc %{_mandir}/man3/%{name}*
%{_bindir}/%{name}
%{_libdir}/libduma.so.*

%files devel
%defattr(-, root, root, 0755)
%exclude %{_libdir}/libduma.a
%{_libdir}/libduma.so
%{_includedir}/*

%changelog
* Mon Jul 13 2015 Moritz Barsnick <moritz+rpm@barsnick.net> 2.5.15-0.4.4sunshine
- use %%dist tag, and bump minor release so it gets recognized as a newer
  version
- drop use of some obsoleted macros
- use standard Sourceforge download URL

* Mon Aug 11 2014 Moritz Barsnick <moritz+rpm@barsnick.net> 2.5.15-0.3sunshine
- fix lib install on 64 bit systems
- avoid having to modify two versions in SPEC

* Mon Aug 11 2014 Moritz Barsnick <moritz+rpm@barsnick.net> 2.5.15-0.2sunshine
- replace ancient %%makeinstall with new %%make_install and provide a
  replacement for older Fedoras
- fix install prefix
- make %%setup quiet
- preserve modification times

* Thu Feb 18 2010 Moritz Barsnick <moritz+rpm@barsnick.net> 2.5.15-0.1sunshine
- update to 2.5.15
- use normed BuildRoot
- remove BR gcc-c++, it's Fedora default
- obey %%{buildflags}
- add a patch for correct usage of open(2)
- add a major patch and a sed line to make the wrapper script functional
- add a patch so that README.txt is not installed by "make install"
- package header in -devel
- package license files
- clarify license (GPLv2 and LGPLv2)

* Wed Sep  5 2007 Dries Verachtert <dries@ulyssis.org> - 2.5.8-2
- Fix build on systems with multiple processors, thanks to Brian Watt.

* Mon Aug 20 2007 Dries Verachtert <dries@ulyssis.org> - 2.5.8-1
- Updated to release 2.5.8.

* Fri Aug 17 2007 Dries Verachtert <dries@ulyssis.org> - 2.5.7-1
- Updated to release 2.5.7.

* Fri Aug 17 2007 Dries Verachtert <dries@ulyssis.org> - 2.5.6-1
- Updated to release 2.5.6.

* Sun Aug 12 2007 Dries Verachtert <dries@ulyssis.org> - 2.5.5-1
- Updated to release 2.5.5.

* Wed Aug 01 2007 Dries Verachtert <dries@ulyssis.org> - 2.5.4-1
- Updated to release 2.5.4.

* Mon Jul 16 2007 Dries Verachtert <dries@ulyssis.org> - 2.5.3-1
- Updated to release 2.5.3.

* Tue Jul 10 2007 Dries Verachtert <dries@ulyssis.org> - 2.5.1-1
- Updated to release 2.5.1.

* Thu Apr 27 2006 Dries Verachtert <dries@ulyssis.org> - 2.4.27-1
- Updated to release 2.4.27.

* Thu Nov 10 2005 Dries Verachtert <dries@ulyssis.org> - 2.4.26-2
- Fixed the project url and source url.

* Fri Oct 28 2005 Dries Verachtert <dries@ulyssis.org> - 2.4.26-1

- Updated to release 2.4.26.

* Sat Oct 08 2005 Dries Verachtert <dries@ulyssis.org> - 2.4.23-1
- Updated to release 2.4.23.

* Fri Oct 07 2005 Dries Verachtert <dries@ulyssis.org> - 2.4.22-1
- Updated to release 2.4.22.

* Tue Sep 20 2005 Dries Verachtert <dries@ulyssis.org> - 2.4.19-1
- Initial package.

